#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h> //isdigit()

#define CHAR_SIZE 256
#define NOTHING 0
#define ONLY_R 1
#define ONLY_W 2
#define ONLY_RW 3


// Arvore digital by www.techiedelight.com/trie-implementation-insert-search-delete/

// stap -g -v -p 4 -D MAXMAPENTRIES=1048576 --suppress-time-limits fonte.stp -m fonte

// A Trie node
struct Trie
{
    int isLeaf;    // n=0, r=1, w=2, rw=3, nao-terminal=4;
    struct Trie* character[CHAR_SIZE]; // indexado sob a tabela ASCII
};



struct s_sys
{
	uint16_t pid;
	uint8_t sys;

	uint8_t size;
	char argstr[256];
	uint8_t sizePrograma;
	char nomePrograma[128];
};

typedef struct filesystem_access
{
	char path[512];
	int flag;
}fs_access;

typedef struct pode_executar
{
	char path[512];
}can_exec;


typedef struct dado
{
	char programa[250];
	struct Trie* f_paths;
	can_exec e_paths[512];

	int max_child;
	int can_send_signal:2;
	int connect_using_tcp:2;
	int send_using_udp:2;
	int port_list[512];

	int quantf_paths;
	int quante_paths;
	int quantPortList;
}dados;

// Function that returns a new Trie node
struct Trie* getNewTrieNode()
{
    struct Trie* node = (struct Trie*)malloc(sizeof(struct Trie));

    node->isLeaf = 4; // nao-terminal
    for (int i = 0; i < CHAR_SIZE; i++)
        node->character[i] = NULL;

    return node;
}

// Iterative function to insert a string in Trie.
void insert(struct Trie* *head, char* str, int flag)
{
    // start from root node
    struct Trie* curr = *head;
    while (*str)
    {
        // create a new node if path doesn't exists
        if (curr->character[*str] == NULL)
            curr->character[*str] = getNewTrieNode();

        // go to next node
        curr = curr->character[*str];

        // move to next character
        str++;
    }

    // mark current node as leaf
    curr->isLeaf = flag; // third param
}

// Iterative function to search a string in Trie. It returns 1
// if the string is found in the Trie, else it returns 0
int search(struct Trie* head, char* str)
{
    // return 0 if Trie is empty
    int i=0;
    if (head == NULL)
        return 0;

    struct Trie *curr = head;
    struct Trie *temp=NULL;
    char *teste=malloc(25*sizeof(char));
    int aux=0;
    //printf("'%s'\n", str);
    while (*str)
    {
        // go to next node
        teste[aux]=*str;
        aux++;
        curr = curr->character[*str];
        if(curr!=NULL)
          if(curr->isLeaf != 4)
          {
            //teste[strlen(teste)]=0;
            //printf("%s\n", teste);
            temp = curr;
          }
        // if string is invalid (reached end of path in Trie)
        if (curr == NULL)
        {
           if(temp!=NULL)
           {
             //printf("AA:%s\n",teste);
             //free(teste);
             return temp->isLeaf;
           }
           else
           {
             free(teste);
             return -1;
           }
        }

        // move to next character
        str++;
        i++;
    }

    // if current node is a leaf and we have reached the
    // end of the string, return 1
    //free(teste);
	if(temp!=NULL)
	{
    	//printf("AA:%s\n",teste);
    	//free(teste);
    	return temp->isLeaf;
	}
    return curr->isLeaf;
}

void get_sys(struct s_sys *s)
{
	fread(&s->pid,1,sizeof(s->pid),stdin);
	fread(&s->sys,1,sizeof(s->sys),stdin);
	if (1)  //TODO
	{
		fread(&s->size,1,sizeof(s->size),stdin);
		fread(&s->argstr,1,s->size,stdin);
		s->argstr[s->size]=0;
		fread(&s->sizePrograma,1,sizeof(s->sizePrograma),stdin);
		fread(&s->nomePrograma,1,s->sizePrograma,stdin);
		s->nomePrograma[s->sizePrograma]=0;
	}
}
char *retornaApenasPalavra(char *token) //remove espacos, tabulacoes, quebra de linha e outros caracteres, deixando apenas, LeTrAs, numeros e /
{
	
	int i,j,tam=strlen(token);
	char *t=malloc(tam);
	j=0;
	for (i=0;i<tam;i++)
	{
		if (token[i] >= 65 && token[i] <= 90 || token[i]>=97 && token[i]<=122 || token[i]>=47 && token[i]<=57)
		{
			t[j]=token[i];
			j++;
		}
	}
	return t;
}

int procuraPolitica(dados *politica, int quantPol, char *nomePrograma)
{
	int i,pos;

	for (i = 0; i < quantPol && nomePrograma!=NULL; i++)
	{
		if (strcmp(politica[i].programa,nomePrograma)==0)
		{
			return i;
		}
	}
	return(-1);
	
}

int buscaPorta(dados politica,int porta)
{
	int i;
	for (i = 0; i < politica.quantPortList; i++)
	{
		if(politica.port_list[i] == porta)
			return (1);
	}
	return 0;
}

int main()
{
	struct s_sys syscall;
	FILE *file;
	char linha[256];
	int i=-1; // posicao da quant de politicas
	int quantPol=0;
	int j;

	dados *politica;

	file = fopen("policies.conf","r");

	if (file==NULL)
	{
		printf("Não foi possível abrir no modo leitura o arquivo de políticas de segurança policies.conf.\n Verifique o nome e as permissões");
		return 0;
	}

	while(fgets(linha,sizeof(linha), file) != NULL)
	{
		if (linha[0]!=35) // # ignora linhas comentadas
		{
			if (strstr(linha,"[") && strstr(linha,"]"))
			{
				quantPol++;
			}
		}
	}
	rewind(file);
	politica = malloc(sizeof(dados)*quantPol);
	for (j = 0; j < quantPol; j++)
	{
		politica[j].f_paths = getNewTrieNode();
		politica[j].quante_paths=0;
		politica[j].quantPortList=0;
	}
	while(fgets(linha,sizeof(linha), file) != NULL)
	{
		if (linha[0]!=35) // # ignora linhas comentadas
		{
			if (strstr(linha,"[") && strstr(linha,"]"))
			{
				i++;
				char *token;
				token = strtok(linha,"[]");
				while(token != NULL)
				{
					if(strstr(token,"/"))
					{
						printf("%s\n",token);
						strcpy(politica[i].programa,token);
					}
					token=strtok(NULL,"[]");
				}
			}
			if (strstr(linha,"fs_access"))
			{
				do
				{
					if(strstr(linha,"/"))
					{
						char *token=NULL;
						char *aux=NULL;

						token = strtok(linha," ,");
						if(token!=NULL)
						{
							aux=retornaApenasPalavra(token);
							//strcpy(politica[i].f_paths[politica[i].quantf_paths].path,token);
						}
						
						token = strtok(NULL," ,");

						if(token!=NULL)
						{
							token=retornaApenasPalavra(token);
							if(strcmp(token,"n")==0)
							{
								//politica[i].f_paths[politica[i].quantf_paths].flag=1;
								insert(&politica[i].f_paths,aux,0);
							}
							else if(strcmp(token,"r")==0)
							{
								//politica[i].f_paths[politica[i].quantf_paths].flag=1;
								insert(&politica[i].f_paths,aux,1);
							}
							else if(strcmp(token,"w")==0)
							{
								//politica[i].f_paths[politica[i].quantf_paths].flag=2;
								insert(&politica[i].f_paths,aux,2);

							}else if(strcmp(token,"rw")==0)
							{
								//politica[i].f_paths[politica[i].quantf_paths].flag=3;
								insert(&politica[i].f_paths,aux,3);
							}
						}
						/*else
						{
							politica[i].f_paths[politica[i].quantf_paths].flag=0;
						}*/
						//printf("%s\n",politica[i].f_paths[politica[i].quantf_paths].path);
						politica[i].quantf_paths++;
					}
					fgets(linha,sizeof(linha),file);
				}while(strstr(linha,"}")==NULL);
			}
			if(strstr(linha,"can_exec"))
			{
				do
				{
					if(strstr(linha,"/"))
					{
						char *token=NULL;

						token = strtok(linha," ,");
						token=retornaApenasPalavra(token);
						
						if(token!=NULL)
						{
							strcpy(politica[i].e_paths[politica[i].quante_paths].path,token);
							//printf("'%s'\n", politica[i].e_paths[politica[i].quante_paths].path);
						}
						politica[i].quante_paths++;
					}
					fgets(linha,sizeof(linha),file);
				}while(strstr(linha,"}")==NULL);
			}
			if (strstr(linha,"max_child"))
			{
				char *token=NULL;

				token = strtok(linha," = ");
				token = strtok(NULL, " = ");
				if(token!=NULL)
				{
					token = retornaApenasPalavra(token);
					//printf("'%s'\n", token);
					politica[i].max_child = atoi(token);
				}
			}
			if (strstr(linha,"can_send_signal"))
			{
				if (strstr(linha,"yes"))
				{
					politica[i].can_send_signal=1;
				}
				if(strstr(linha,"no"))
				{
					politica[i].can_send_signal=0;
				}
			}
			if (strstr(linha,"connect_using_tcp"))
			{
				if (strstr(linha,"yes"))
				{
					politica[i].connect_using_tcp=1;
				}
				if(strstr(linha,"no"))
				{
					politica[i].connect_using_tcp=0;
				}
			}
			if (strstr(linha,"send_using_udp"))
			{
				if (strstr(linha,"yes"))
				{
					politica[i].send_using_udp=1;
				}
				if(strstr(linha,"no"))
				{
					politica[i].send_using_udp=0;
				}
			}
			if (strstr(linha,"port_list"))
			{
				char *token=NULL;

				token=strtok(linha," ,");
				
				while(token != NULL)
				{
					token=strtok(NULL, " ,");
					
					if (token!=NULL)
					 {
						if(isdigit(token[0]))
						{
							politica[i].port_list[politica[i].quantPortList] = atoi(token);
							politica[i].quantPortList++;
							//printf("%d\n", politica[i].port_list[politica[i].quantPortList]);
						};
					}
				}
			}
		}
	}
	
	int k;

	fclose(file);
	/*char test[200];
	while(1)
	{
		scanf("%s", test);
		printf("TESTE:%d\n", search(politica[1].f_paths,test));
	}*/
	
	while(1)
	{
		get_sys(&syscall);
		//printf("B: %d:%s\n",syscall.sys,syscall.argstr);
		
		int pos = procuraPolitica(politica,quantPol,syscall.nomePrograma);
		if(pos != -1)
		{
			if(syscall.sys == 2) // open
			{
				//printf("pid %u sys %u ",syscall.pid,syscall.sys);
				//printf("%s\n", syscall.argstr);
				
				char *dir; // diretorio pego pela open
	 			//char *flagSys; // flag do open obtida pelo SystemTap
				
				char *tok = strtok(syscall.argstr,"\","); // "/etc/ld.so.cache", O_RDONLY|O_CLOEXEC
				
				int res;

				dir=tok; // salvei o diretorio 
				
				tok = strtok(NULL,", |");
				res = search(politica[pos].f_paths,dir);
				//printf("%d:%s:%s\n",res,dir,tok);

				if(res == 0) // se eu tento fazer qualquer open em um diretorio com nenhum tipo de permissao => WARNING
				{
					printf("Warning 0!: %d:%s:%s\n ",res,dir,tok);
				}
				if(res == 1 && (strstr(tok,"O_WRONLY")!=NULL || strstr(tok, "O_RDWR")!=NULL)) // e permitido fazer open em modo de leitura, se houver escrita => WARNING
				{
					printf("Warning 1: %d:%s:%s\n",res,dir,tok);
				}
				
				if(res == 2 && (strstr(tok,"O_RDONLY")!=NULL || strstr(tok, "O_RDWR")!=NULL)) // e permitido fazer open em modo de escrita, se houver leitura => WARNING
				{
					printf("Warning 2: %d:%s:%s\n",res,dir,tok);
				}
				/*if(res == 3 && (strstr(tok,"O_RDWR")!=NULL || strstr(tok,"O_RDONLY")!=NULL || strstr(tok,"O_WRONLY")!=NULL))
				{
					printf("Warning 3: %d:%s:%s\n",res,dir,tok);
				}*/
			}
			
			if(syscall.sys == 41) // socket
			{
				//printf("TCP %d %d %d\n", politica[pos].can_send_signal, politica[pos].connect_using_tcp, politica[pos].send_using_udp);
				if (strstr(syscall.argstr, "SOCK_STREAM") && politica[pos].connect_using_tcp!=1) // connect TCP igual a nao
				{
					printf("Warning: SOCKET using TCP\n");
				}
				if (strstr(syscall.argstr, "SOCK_DGRAM") && politica[pos].send_using_udp!=1) // connect UDP igual a nao
				{
					printf("Warning: SOCKET using UDP\n");
				}
			}

			if(syscall.sys == 42) // connect
			{
				char *tok;
				int porta;

				tok = strtok(syscall.argstr,", ");
				tok = strtok(NULL,", ");
				tok = strtok(NULL,", ");
				tok = strtok(NULL,", }");
				
				porta = atoi(tok);
				if(buscaPorta(politica[pos], porta) == 0)
				{
					printf("Warning: PORTA %d\n", porta);
				}
			}

			if(syscall.sys == 56) // clone
			{
				//printf("pid %u sys %u ",syscall.pid,syscall.sys);
				//printf("%s\n", syscall.argstr);
				if(politica[pos].max_child==0)
				{
					printf("Warning!\n");
				}
			}
		}
	}

	return 0;
}
/*
	agora, em todos os argstr tem o caminho onde foi feito a execucao do programa. 
*/